( Screen editor version 1.5 ,   Forth 83,   1985 G.W.Jackson  )
( Last modified 8 February 1985 )
( This version opens the display windows on entry and closes them on exit )
( and is used to generate the standalone version of FORTH + Editor )
( Switch to floppy disc added with ALT F or f )

DECIMAL CLS

VOCABULARY EDITOR IMMEDIATE
EDITOR DEFINITIONS

: #CON 2CONSTANT  DOES> 2@ 2DUP #IN 2! #OUT 2! ;

0 0 #CON #0            ( loaded with channel ID's below )
0 0 #CON #1
0 0 #CON #2
0 0 #CON #3

: OPEN_WIN 32768 - 0 32776 2@ D+ 0 1 TRAP2 DUP ?ERROR ; ( ad --- ID )

: WIN_WORD CREATE BL WORD 0 HERE ! HERE 1+ OVER C@ 1+ CMOVE
                  HERE @ 2+ ALLOT
           DOES>  OPEN_WIN ;

#DEFAULT ' #0 >BODY 2!

3 LOAD

CLS CR 3 1 CSIZE .(     LOADING EDITOR ) CR 0 0 CSIZE

: INIT_WINS
      #DEFAULT [ ' #0 >BODY ] LITERAL 2!
      #1W      [ ' #1 >BODY ] LITERAL 2!
      #2W      [ ' #2 >BODY ] LITERAL 2!
      #3W      [ ' #3 >BODY ] LITERAL 2!
      #0 CLS
      SET_PARS   ;

: OFF >BODY 2@ CLOSE ;

: CLOSE_ALL
      ['] #1 OFF
      ['] #2 OFF
      ['] #3 OFF   ;

VARIABLE R#
VARIABLE LCOL           VARIABLE 1OR2

: C_XY R# @ C/L /MOD ;
: CCOL C_XY DROP ;    : CLINE C_XY SWAP DROP ;
: C_ON 14 CSOR   ;    : C_OFF 15 CSOR ;
: C_AD R# @ SCR @ BLOCK + ;
: LN_AD C/L * SCR @ BLOCK + ;
: C_PUT >R >R 0 16 #OUT 2@ R> LCOL @ - 0 R>
        TRAP3* DUP ?ERROR 2DROP   ;
: .RLN C/D SWAP LCOL @ 2DUP >= IF - - TYPE
         ELSE 2DROP 2DROP THEN   ;
: .RLINE .RLN C_XY C_PUT ;
: .LINE LCOL @ OVER C_PUT LN_AD LCOL @ + LCOL @ .RLINE ;
: .RBLK L/B SWAP DO I .LINE LOOP ;

: PAD1 HERE 200 + ;   : PAD2 PAD1 C/L + ;
: .PADS #3 CLS PAD1 LCOL @ + LCOL @ .RLN
        LCOL @ 1 C_PUT PAD2 LCOL @ + LCOL @ .RLN #2   ;
: .BLOCK CLS 0 .RBLK .PADS ;
: C_SHOW CCOL LCOL @ - C/D U< 0=
         IF C/D 2/ CCOL OVER / * C/L C/D - MIN
            LCOL ! .BLOCK THEN    ;
: MOVE_C R# @ + B/BUF + B/BUF MOD R# !
         C_SHOW C_XY C_PUT  ;
: DOWN C/L MOVE_C ;      : UP C/L NEGATE MOVE_C ;
: LEFT -1  MOVE_C ;      : RIGHT 1 MOVE_C ;
: .NLN 1OR2 @ IF CLINE 1+ DUP L/B < IF .LINE THEN THEN ;

: .TITLE CLS 5 SPACES ." Block " SCR @ .  ;
: ENTRY #0 CLS  #2 B_COL 2 BORDER CLS  DUP SCR ! 0 LCOL !
      0 R# !    #3 B_COL 2 BORDER CLS
      #1   B_COL 2 BORDER BLOCK DROP .TITLE
      #2  .BLOCK  ;
: FINISH  #3 B_OFF 2 BORDER CLS
          #2 B_OFF 2 BORDER  #1 B_OFF 2 BORDER
          #0 0 LCOL ! 0 22 C_PUT ." EDIT finished "
          10 [ ' TIMEOUT >BODY ] LITERAL !   ( A trick, avoid SB switching  )
                                             ( input to another task )
          TIB 1 #IN 2@ 1 TRAP3 DROP 2DROP    ( Read a character )
          -1 [ ' TIMEOUT >BODY ] LITERAL !
          CLOSE_ALL   ;
: L_LN C/L 1OR2 @ IF CLINE 1+ L/B < IF 2* THEN THEN
       CCOL 1+ -   ;
: DEL_CHAR BL C_AD DUP 1+ DUP 1- L_LN DUP >R
      CMOVE R> + C! C_AD CCOL .RLINE .NLN  UPDATE   ;
: DEL_LEFT LEFT DEL_CHAR  ;
: INS_CHAR C_AD DUP DUP 1+ L_LN
      CMOVE> C! C_AD CCOL .RLINE .NLN RIGHT UPDATE  ;

: T1/2 -1 1OR2 @ - 1OR2 ! ;
: NXT_LN C/L CCOL - MOVE_C ;
: LOSE_LN CLINE LN_AD DUP C/L + SWAP B/BUF CLINE 1+ C/L
     * - CMOVE L/B 1- LN_AD C/L BL FILL CLINE .RBLK
     UPDATE  ;
: DEL_LN CLINE LN_AD SWAP C/L CMOVE LOSE_LN  ;
: >PAD1 PAD1 DEL_LN .PADS ;  : >PAD2 PAD2 DEL_LN .PADS ;

: INS_LN CLINE DUP 1+ L/B < IF LN_AD DUP C/L + B/BUF
      CLINE 1+ C/L * - CMOVE> ELSE DROP THEN
      CLINE LN_AD C/L CMOVE CLINE .RBLK UPDATE ;
: PAD1> PAD1 INS_LN ;     : PAD2> PAD2 INS_LN ;
: CL_PADS PAD1 C/L 2* BL FILL .PADS ;
: NEXT_BLK SCR @ 1+ ENTRY  ;
: PREV_BLK SCR @ 1- ENTRY  ;
: ABANDON 1 SCR @ BLOCK 2- C! DROP 27 ;

: BLK? ." Block " TIB 10 EXPECT 0 >IN ! BL WORD
       DUP C@ IF 0 0 ROT CONVERT 2DROP 1
              ELSE C@ THEN  ;
: NEW_BLK #1 CLS ."   Read " BLK? 0= IF SCR @ THEN
              ENTRY ;

: SAVE UPDATE SAVE-BUFFERS ;
: STUN 1 SCR @ BLOCK 2- C! ;
: NEW #1 CLS ."   new " BLK?
          IF DUP BUFFER DROP ELSE SCR @ THEN ENTRY ;
: SAVE_AS #1 CLS ."   save as " BLK?
          IF DUP SCR @ BLOCK 2- 2- ! SAVE
             SCR ! THEN .TITLE #2 ;
: DELAY 20000 0 DO LOOP ;

: GET_N        ( --- n  n )
         C_ON KEY C_OFF
         48 - DUP 1-      ;

: TO_MDV #1 CLS ."   to MDV "
         GET_N  7 U<
         IF DUP . MDV
         ELSE DROP ." ??" DELAY
         THEN .TITLE #2 ;

: TO_FLP #1 CLS ."   to FLP "
         GET_N 2 U<
         IF DUP . FLP
         ELSE DROP ." ??" DELAY
         THEN .TITLE #2 ;

: NO_ACTION #1 CLS ."   No action for this key"
            DELAY .TITLE #2 ;

: ALT KEY CASE  77 OF TO_MDV     ENDOF    ( ALT M )
               109 OF TO_MDV     ENDOF    ( ALT m )
                84 OF T1/2       ENDOF    ( ALT T )
               116 OF T1/2       ENDOF    ( ALT t )
                70 OF TO_FLP     ENDOF    ( ALT F )
               102 OF TO_FLP     ENDOF    ( ALT f )
               DEFAULT NO_ACTION
          ENDCASE     ;

: ?VIS BL 1- OVER < OVER 192 < AND IF 1 THEN ;
: EDIT
   INIT_WINS
   BASE @ DECIMAL SWAP CL_PADS ENTRY
   BEGIN C_SHOW C_ON KEY C_OFF DUP
    CASE ?VIS 1 OF INS_CHAR ENDOF
            192 OF LEFT     ENDOF
            200 OF RIGHT    ENDOF
            208 OF UP       ENDOF
            216 OF DOWN     ENDOF
            194 OF DEL_LEFT ENDOF
            202 OF DEL_CHAR ENDOF
             10 OF NXT_LN   ENDOF
            232 OF >PAD1    ENDOF
            233 OF PAD1>    ENDOF
            236 OF >PAD2    ENDOF
            237 OF PAD2>    ENDOF
            235 OF LOSE_LN  ENDOF
            240 OF NEW_BLK  ENDOF
            241 OF NEXT_BLK ENDOF
            242 OF PREV_BLK ENDOF
            218 OF CL_PADS  ENDOF
            244 OF SAVE     ENDOF
            245 OF SAVE_AS  ENDOF
            248 OF NEW      ENDOF
            250 OF STUN     ENDOF
            255 OF ALT      ENDOF
             31 OF ABANDON  ENDOF
             27 OF          ENDOF
          DEFAULT NO_ACTION
          ENDCASE 27 = UNTIL FINISH BASE ! ;
FORTH DEFINITIONS
: EDIT EDITOR EDIT FORTH ;
CLS CR CR .(    Screen Editor loaded )
END_FILE 
